<template>
  <div class="app-container">
    <!-- 搜索工作栏 -->
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="变动单号" prop="dealNo">
        <el-input v-model="queryParams.dealNo" placeholder="请输入处置单" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      <el-form-item label="变动日期" prop="dealDateArray">
        <el-date-picker v-model="queryParams.dealDateArray" style="width: 240px" value-format="yyyy-MM-dd HH:mm:ss"
                        type="daterange" range-separator="-" start-placeholder="开始日期" end-placeholder="结束日期"
                        :default-time="['00:00:00', '23:59:59']"
        />
      </el-form-item>
      <el-form-item v-show="false" label="数据类型" prop="dataType">
        <el-select v-model="queryParams.dataType" placeholder="请选择处置方式" clearable size="small">
          <el-option v-for="dict in this.getDictDatas(DICT_TYPE.PROPERTY_DATA_TYPE)" :key="dict.value"
                     :label="dict.label"
                     :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <!-- 操作工具栏 -->
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="openForm(undefined)"
                   v-hasPermi="['company:property-deal:create']"
        >新增
        </el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="list" :stripe="true" :show-overflow-tooltip="true">
      <el-table-column label="序号" align="center" prop="num">
        <template slot-scope="scope">
          <span style="margin-left: 10px">{{
              queryParams.pageSize * (queryParams.pageNo - 1) + scope.$index + 1
            }}</span>
        </template>
      </el-table-column>
      <el-table-column label="变动单号" align="center" prop="propertyDeal.dealNo" width="180"/>
      <el-table-column label="资产编号" align="center" prop="property.propNo" width="180"/>
      <el-table-column label="资产名称" align="center" prop="property.propName" width="180"/>
      <el-table-column label="变动时间" align="center" prop="propertyDeal.dealDate" width="180"/>
      <el-table-column label="原企业" align="center" prop="oldCorpId" width="180">
        <template #default="{ row }">
          {{ CompanyName(row.oldCorpId) }}
        </template>
      </el-table-column>
      <el-table-column label="调入企业" align="center" prop="corpId" width="180">
        <template #default="{ row }">
          {{ CompanyName(row.corpId) }}
        </template>
      </el-table-column>
      <el-table-column label="原存放地" align="center" prop="oldPosId" width="180">
        <template #default="{ row }">
          {{ PositionName(row.oldPosId) }}
        </template>
      </el-table-column>
      <el-table-column label="调入存放地" align="center" prop="posId" width="180">
        <template #default="{ row }">
          {{ PositionName(row.posId) }}
        </template>
      </el-table-column>
      <el-table-column label="原使用人" align="center" prop="oldUserId" width="180">
        <template #default="{ row }">
          {{ StaffName(row.oldUserId) }}
        </template>
      </el-table-column>
      <el-table-column label="调入使用人" align="center" prop="userId" width="180">
        <template #default="{ row }">
          {{ StaffName(row.userId) }}
        </template>
      </el-table-column>
      <el-table-column label="取得方式" align="center" prop="dealWay" width="150px">
        <template v-slot="scope">
          <dict-tag :type="DICT_TYPE.PROPERTY_GET_WAY" :value="scope.row.dealWay"/>
        </template>
      </el-table-column>
      <el-table-column label="备注" align="center" prop="remark" width="180"/>
      <el-table-column fixed="right" label="操作" align="center" class-name="small-padding fixed-width" width="200">
        <template v-slot="scope">
          <el-button size="mini" type="text" icon="el-icon-edit" @click="openForm(scope.row.id)"
                     v-hasPermi="['company:property-deal:update']"
          >修改
          </el-button>
          <el-button size="mini" type="text" icon="el-icon-delete" @click="handleDelete(scope.row)"
                     v-hasPermi="['company:property-deal:delete']"
          >删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>

    <!-- 分页组件 -->
    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNo" :limit.sync="queryParams.pageSize"
                @pagination="getList"
    />

    <!-- 对话框(添加 / 修改) -->
    <PropertyDealChangeForm ref="formRef" @success="getList"/>
  </div>
</template>

<script>
import * as PropertyDealItemApi from '@/api/company/property/propertydealitem'
import PropertyDealChangeForm from '@/views/company/property/propertyDealChange/form/PropertyDealChangeForm'
import { getCompany } from '@/api/base/company'
import { getStaffById } from '@/api/company/staff'
import { getPropertyPos } from '@/api/company/property/position'

export default {
  name: 'PropertyDealChange',
  components: {
    PropertyDealChangeForm
  },
  data() {
    return {
      // 遮罩层
      loading: false,
      // 导出遮罩层
      exportLoading: false,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 企业管理-资产处置子列表
      list: [],
      // 查询参数
      queryParams: {
        pageNo: 1,
        pageSize: 10,
        dealNo: undefined,
        dealDateArray: [],
        dataType: '01',
        dealWay: undefined
      },
      companyNamesCache: {}, // 用于缓存已经获取的公司名称
      staffNamesCache: {}, // 用于缓存已经获取的公司名称
      positionNamesCache: {} // 用于缓存已经获取的公司名称
    }
  },
  created() {
    this.getList()
  },
  computed: {
    CompanyName() {
      return (id) => {
        if (this.companyNamesCache[id]) {
          return this.companyNamesCache[id]
        }
        // 如果不在缓存中，则发起异步请求
        return this.getCompanyById(id)
      }
    },
    StaffName() {
      return (id) => {
        if (this.staffNamesCache[id]) {
          return this.staffNamesCache[id]
        }
        // 如果不在缓存中，则发起异步请求
        return this.getStaffByUserId(id)
      }
    },
    PositionName() {
      return (id) => {
        if (this.positionNamesCache[id]) {
          return this.positionNamesCache[id]
        }
        // 如果不在缓存中，则发起异步请求
        return this.getPositionById(id)
      }
    }
  },
  methods: {
    /** 查询列表 */
    async getList() {
      try {
        this.loading = true
        const res = await PropertyDealItemApi.getPropertyDealItemPage(this.queryParams)
        this.list = res.data.records
        this.total = res.data.total
      } finally {
        this.loading = false
      }
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNo = 1
      this.getList()
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm('queryForm')
      this.handleQuery()
    },
    /** 添加/修改操作 */
    openForm(id) {
      this.$refs['formRef'].open(id)
    },
    /** 删除按钮操作 */
    async handleDelete(row) {
      const id = row.id;
      await this.$modal.confirm('是否确认删除企业管理-资产处置子编号为"' + id + '"的数据项?')
      try {
        await PropertyDealItemApi.deletePropertyDealItem(id);
        await this.getList();
        this.$modal.msgSuccess("删除成功");
      } catch { }
    },
    async getCompanyById(id) {
      try {
        if (!this.companyNamesCache[id]) {
          const res = await getCompany(id)
          const name = res.data.corpName
          this.$set(this.companyNamesCache, id, name)
        }
        return this.companyNamesCache[id]
      } catch {
      }
    },
    async getStaffByUserId(id) {
      try {
        if (!this.staffNamesCache[id]) {
          const res = await getStaffById(id)
          const name = res.data.name
          this.$set(this.staffNamesCache, id, name)
        }
        return this.staffNamesCache[id]
      } catch {
      }
    },
    async getPositionById(id) {
      try {
        if (!this.positionNamesCache[id]) {
          const res = await getPropertyPos(id)
          const name = res.data.posName
          this.$set(this.positionNamesCache, id, name)
        }
        return this.positionNamesCache[id]
      } catch {
      }
    }
  }
}
</script>

<style scoped lang="scss">
</style>
